﻿Type=StaticCode
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private Sql1 As SQL
	Private Rs As  ResultSet
	Private strSql As String
End Sub

Public Sub sql_IsInitialized As Boolean
	Return Sql1.IsInitialized
End Sub

Public Sub InitSql
	Sql1.InitializeSQLite(File.DirApp, "Sokoban.db", True)
	Sql1.ExecNonQuery("CREATE TABLE IF NOT EXISTS Images (Id INTEGER PRIMARY KEY, Img BLOB)")
	Sql1.ExecNonQuery("CREATE TABLE IF NOT EXISTS Games (Num INTEGER PRIMARY KEY, nChars TEXT)")
End Sub

Public Sub insert_Image(id As Int, im As Image)
	strSql="INSERT INTO Images VALUES(" & id & ",  " & Null & ")"
	Sql1.ExecNonQuery(strSql)	
	Dim Out As OutputStream
	Dim Buffer() As Byte
	Out.InitializeToBytesArray(10000)
	im.WriteToStream(Out)
	Buffer = Out.ToBytesArray
	Out.Close 
	strSql="UPDATE Images SET Img = ? WHERE (Id = " & id  & ")"
	Sql1.ExecNonQuery2(strSql, Array As Object(Buffer))
End Sub

Public Sub Get_Image(id As Int) As Image
	Dim Buffer() As Byte 
	Dim InpStr As InputStream
	Dim tmpImg As Image 
	strSql = "Select Img From Images WHERE(Id = " & id & ")"
	Rs = Sql1.ExecQuery(strSql)
	If Rs.NextRow Then
		Buffer = Rs.GetBlob("Img")
		InpStr.InitializeFromBytesArray(Buffer, 0, Buffer.Length)
		tmpImg.Initialize2(InpStr)
		InpStr.Close
	End If
	Return tmpImg
End Sub

Public Sub Save_New_Game(nChars(,) As Char)
	Dim str As String
	Dim Separ As String = ""
	Dim NewNum As Int
	strSql = "Select Max(Num) as N From Games"
	Rs = Sql1.ExecQuery(strSql)
	NewNum = Rs.GetInt("N") + 1
	str = ""
	For y = 0 To 19
		str = str & Separ
		For x = 0 To 19
			str = str & nChars(x, y)
		Next
		Separ = ","
	Next
	strSql="INSERT INTO Games VALUES(" & NewNum & ", '" & str & "')"   
	Sql1.ExecNonQuery(strSql)	
End Sub

Public Sub Updt_Game(Gm As Int, nChars(,) As Char)
	Dim str As String
	Dim Separ As String = ""
	Dim GNum As Int = Gm
	str = ""
	For y = 0 To 19
		str = str & Separ
		For x = 0 To 19
			str = str & nChars(x, y)
		Next
		Separ = ","
	Next
	strSql = "UPDATE Games SET nChars = '" & str & "' WHERE(Num = " & GNum & ")"
	Sql1.ExecNonQuery(strSql)
End Sub

Public Sub Delete_Game(Gm As Int)
	Dim GNum As Int = Gm
	strSql = "DELETE from Games WHERE(Num = " & GNum & ")"
	Sql1.ExecNonQuery(strSql)
End Sub

Public Sub Load_Game(Gm As Int) As Char(,)
	Dim tbRet(20, 20) As Char
	strSql = "Select nChars From Games Where(Num = " & Gm & ")"
	Rs = Sql1.ExecQuery(strSql)
	If Rs.NextRow Then
		Dim str As String = Rs.GetString("nChars")
		Dim yChars() As String = Regex.Split(",", str)
		For y = 0 To yChars.Length - 1
			For x = 0 To yChars(y).Length - 1
				tbRet(x, y) = yChars(y).SubString2(x, x + 1)
			Next 
		Next
	End If
	Return tbRet
End Sub

Public Sub GetLst(lstV As ListView)
	lstV.Items.Clear
	strSql = "Select Num From Games Order by Num Asc"
	Rs = Sql1.ExecQuery(strSql)
	Do While Rs.NextRow
		lstV.Items.Add(NumberFormat2((Rs.GetInt("Num")), 4, 0, 0, False))
	Loop
End Sub

Public Sub Close_Sql
	Sql1.close
End Sub